"""Group picker implementation

    begin                : <2003-01-15 17:55:58 rnc>
    copyright            : (C) 2002 by Ricardo Niederberger Cabral
    email                : nieder|at|mail.ru
    Time-stamp:            <03/03/09 01:50:15 rnc>
"""

## ***************************************************************************
## *                                                                         *
## *   This program is free software; you can redistribute it and/or modify  *
## *   it under the terms of the GNU General Public License as published by  *
## *   the Free Software Foundation; either version 2 of the License, or     *
## *   (at your option) any later version.                                   *
## *                                                                         *
## ***************************************************************************

from string import *
import time

import Error

try:
    from qt import *
except:
    Error.qtImportError()
try:
    from GroupPickerForm import *
    import Settings
except:
    print "GroupPickerForm: Unable to import some imgSeek modules. Some features will not work."

class GroupPickerWnd(GroupPickerForm):
    def __init__(self,parent,callback): 
        GroupPickerForm.__init__(self, parent,"",1)
        self.curdb=Settings.curdb
        self.callback=callback
        self.group=-1
        self.BrowseCategListView.clear()
        for gid in self.curdb.groups.keys():
            self.groupCombo.insertItem(self.curdb.groups[gid][0])
            if self.curdb.groups[gid][2]==-1: #root group
                self.addGroupToView(self.BrowseCategListView,gid)
        
        self.show()
    def addGroupToView(self,parent,gid):
        #print "dirid on adddir",dirid,parent
        lvi=QListViewItem(parent,self.curdb.groups[gid][0],str(len(self.curdb.groups[gid][3]))+" file(s) / "+str(len(self.curdb.groups[gid][4]))+" group(s)")
        lvi.groupid=gid
        lvi.setPixmap(0,Settings.wnd.bookicon)
        for chid in self.curdb.groups[gid][4]:
            self.addGroupToView(lvi,chid)        
    def okbtn_clicked(self):
        self.callback(self.group)
        self.close()
    def groupCombo_activated(self,a0):
        self.group=self.curdb.groups.keys()[a0]
    def createGroupbtn_clicked(self):
        text = str(QInputDialog.getText("imgSeek","New group name:" ,QLineEdit.Normal, time.asctime(time.localtime()))[0])
        if text:            
            nid=self.curdb.newGroup(text)
            if  nid == -1:
                QMessageBox.information( self,"Group name already exists. Please try another.")
                return                              
            self.addGroupToView(self.BrowseCategListView,nid)
            self.groupCombo.insertItem(text)
            self.groupCombo.setCurrentText(text)            
    def BrowseCategListView_clicked(self,a0):
        if not a0:return
        self.group=a0.groupid
        self.groupCombo.setCurrentText(self.curdb.groups[self.group][0])
