"""Settings module

This module will also hold global vars indicating if a given module is present or not

    begin                : Sat Dec 14 2002
    copyright            : (C) 2002 by Ricardo Niederberger Cabral
    email                : nieder|at|mail.ru
    Time-stamp:            <03/03/09 02:17:47 rnc>
"""
## ***************************************************************************
## *                                                                         *
## *   This program is free software; you can redistribute it and/or modify  *
## *   it under the terms of the GNU General Public License as published by  *
## *   the Free Software Foundation; either version 2 of the License, or     *
## *   (at your option) any later version.                                   *
## *                                                                         *
## ***************************************************************************

from string import *
import ConfigParser
import sys,os

ConfigDefault = {
    "browse.showdotfiles":        "0",
    "browse.thumbsingleclick":    "0",
    "browse.showmetadialog":      "0",                        
    "browse.groupthreshold":      "50",
    "browse.dragpopup":           "1",
    "browse.askbeforehugethumb":      "1",
    "database.recursiveadd":      "1",
    "database.beep":               "0",
    "database.alwayssave":        "1",
    "database.autoopen":          "~/.imgseek/img-db.iqd",
    "database.hideprogress"    :  "1",
    "database.alwayssave"    :  "1",
    "view.mainwidth":             "700",
    "view.mainheight":            "600",
    "view.maintab":               "0",
    "view.browsetab":               "0",
    "view.vsplit1":               "170",
    "view.vsplit2":               "236",    
    "view.hsplit1":               "144",
    "view.hsplit2":               "144",            
    "view.slidedelay":            "3",
    "view.autofit":               "0",
    "view.recurseslide":           "1",
    "view.smoothscale":               "1",
    "view.ssplit1":               "226",
    "view.ssplit2":               "180",            
    "query.realtimesketch":       "1"            
    }
################### GLOBAL VARS
# features vars
global hasImMagick,hasPIL,hasIPTC,hasExport,qtv
# instance vars
global options,wnd,curdb,app
# supported extension vars
global exif_ext,iptc_ext,magick_ext,qt_ext,supported_ext,doc_ext,pil_ext
qtv=3                                   # qt version. Should be set by ImgDb
qt_ext=[]
magick_ext=[]
pil_ext=[]
supported_ext=[]
doc_ext=["txt","pdf","ps","htm","html"]
options={} # will hold all app preferences
hasImMagick=0                    # if imageMagick C++ support is being used.
hasPIL =0                         # if PIL module was found.
hasIPTC=0                               # if PIL iptc module was found
hasExport=0                             # if export (dsv/xml) modules where found
###################
#### guess imgSeekLib data dir
global imgseekdatadir
imgseekdatadir=sys.exec_prefix+"/share/imgSeek/"
if not os.path.exists(imgseekdatadir):
    imgseekdatadir=sys.exec_prefix+"/share/imgseek/"
if not os.path.exists(imgseekdatadir):
    imgseekdatadir=sys.exec_prefix+"/share/imgSeekLib/"
if not os.path.exists(imgseekdatadir):
    imgseekdatadir=sys.exec_prefix+"/imgSeekLib/"
if not os.path.exists(imgseekdatadir):
    print "[Error] Unable to detect imgSeekLib data directory. Make sure imgSeek was installed properly, and report your linux distribution and installation method to nieder@mail.ru"
    imgseekdatadir=sys.exec_prefix+"/share/imgSeek/" # get back to default value

def uniquer(seq, idfun=None):
    """helper function for WriteConfig """
    if idfun is None:
        def idfun(x): return x
    seen = {}
    result = []
    for item in seq:
        marker = idfun(item)
        if marker in seen: continue
        seen[marker] = 1
        result.append(item)
    return result

def LoadConfig(file, config={}):
    """
    returns a dictionary with key's of the form
    <section>.<option> and the values
    """
    config = config.copy()
    cp = ConfigParser.ConfigParser()
    cp.read(file)
    for sec in cp.sections():
        name = lower(sec)
        for opt in cp.options(sec):
            config[name + "." + lower(opt)] = strip(cp.get(sec, opt))
    return config
def WriteConfig(file, config):
    """
    given a dictionary with key's of the form 'section.option: value'
    write() generates a list of unique section names
    creates sections based that list
    use config.set to add entries to each section
        """
    f= open(file,'w')
    cp = ConfigParser.ConfigParser()
    #a little string hacking because our section names are un-normalized
    #this builds a list of all the sections names
    sectionslst = []
    sections = []
    for k in config.keys():
        sectionslst.append(split(k,".")[0])
    #get unique entries
    sections = uniquer(sectionslst)
    for sec in sections:
        #make the headers
        cp.add_section(sec)
        #for each item in my dictionary
        #it splits the key in two and uses that for the first and second "set" args
        #then it uses the item.value for the 3rd arg
        # from 'section.option:value'
    for k in config.items():
        cp.set(split(k[0],".")[0],split(k[0],".")[1] ,k[1] )
    cp.write(f)
    f.close()
