"""Database callback module

    begin                : 2003-01-26 09:03:06 rnc
    copyright            : (C) 2002 by Ricardo Niederberger Cabral
    email                : nieder|at|mail.ru
    Time-stamp:            <03/03/08 22:41:26 rnc>
"""

## ***************************************************************************
## *                                                                         *
## *   This program is free software; you can redistribute it and/or modify  *
## *   it under the terms of the GNU General Public License as published by  *
## *   the Free Software Foundation; either version 2 of the License, or     *
## *   (at your option) any later version.                                   *
## *                                                                         *
## ***************************************************************************

import Settings

### GLOBALS
curdb=None
wnd=None                                # points to MainForm

### Callbacks
def cbAll(what=None):
    """called whenever there is the slightest modification to db """
    if what and what.has_key("save") and not what["save"]: return
    if not curdb.doNotSave and int(Settings.options["database.alwayssave"]):
        if curdb and not curdb.savedb():
            wnd.msgerror("Error saving database file.")
def cbGroup(what):
    wnd.updateGroupList()
    cbAll(what)
    wnd.updateAddTab()
def cbDir(what):
    wnd.updateDirList()
    cbAll(what)
def cbMeta(what):
    wnd.updateDirList()
    cbAll(what)
def cbSimGroup(what):
    wnd.updateCategoryView()
    cbAll(what)
def cbVolume(what):
    wnd.updateDirList()
    wnd.updateAddTab()    
    cbAll(what)
def cbDatabase(what):
    if what["reason"]=="reset":
        curdb.doNotSave=1
        cbGroup(None)
        cbDir(None)
        cbVolume(None)
        cbImg(None)
        cbBatch(None)
        wnd.updateAddTab()        
        curdb.doNotSave=0
        # close dialogs to make sure every data is in sync
        if wnd:
            wnd.updateStatusInfo()
            if wnd.MetaForm:
                wnd.MetaForm.close()
                del wnd.MetaForm
                wnd.MetaForm=None
            if wnd.AlbumForm:
                wnd.MetaForm.close()                
            if wnd.BatchMgrFrm:
                wnd.MetaForm.close()                
            if wnd.DuplicateForm:
                wnd.MetaForm.close()                
            if wnd.ExportForm:
                wnd.MetaForm.close()                
            if wnd.ImportForm:
                wnd.MetaForm.close()                
            if wnd.TransformForm:
                wnd.MetaForm.close()
    if what["reason"]=="opened":
        curdb.doNotSave=1
        cbGroup(None)
        cbDir(None)
        cbMeta(None)
        cbSimGroup(None)
        cbVolume(None)
        cbImg(None)
        cbBatch(None)
        if wnd:
            wnd.updateStatusBar(what["subject"]+" opened successfully.")
        wnd.updateAddTab()
        curdb.doNotSave=0
    if what["reason"]=="saved":
        if wnd:
            wnd.updateStatusBar(what["subject"]+" saved.")        
def cbImg(what):
    cbDir(None)
    cbGroup(None)
    wnd.refreshIconView()
def cbBatch(what):
    pass

