"""CSV export module

    begin                : 2003-01-26 00:37:12 rnc
    copyright            : (C) 2002 by Ricardo Niederberger Cabral
    email                : nieder|at|mail.ru
    Time-stamp:            <03/03/08 22:40:55 rnc>
"""

## ***************************************************************************
## *                                                                         *
## *   This program is free software; you can redistribute it and/or modify  *
## *   it under the terms of the GNU General Public License as published by  *
## *   the Free Software Foundation; either version 2 of the License, or     *
## *   (at your option) any later version.                                   *
## *                                                                         *
## ***************************************************************************

import traceback

from  dbExport import *
import DSV

class dbExportDSV(dbExport):
    def __init__(self,db,opts,batch):
        dbExport.__init__(self,db,opts)
        self.opts=opts
        self.batch=batch

    def do(self):
        """# export only metadata """
        imglist=[]
        ln=""
        for fld in self.curdb.metafields:
            ln=ln+fld+','
        self.outmeta.write(ln[:-1]+"\n")
        self.curdb.crawlBatchContentsForImg(self.batch,imglist)
        for id in imglist:
            line=""
            mt=self.curdb.meta[id]
            for fld in self.curdb.metafields:
                if mt.has_key(fld):
                    line=line+'\"'+str(mt[fld])+"\""
                line=line+','
            #TODO:PORT: change \n to proper \n\r or whatevcer on win32
            self.outmeta.write(line[:-1]+"\n") # -1 to remove trailing ,
        self.done()
        return "Data succesfully exported:\n%s." %(self.opts["outdir"]+"metadata.csv")

class dbImportDSV:
    def __init__(self,db,wnd):
        self.wnd=wnd
    def previewFile(self,lines=0):
        """ return lines lines of data. if lines is zero, return all data found on file
        return is a list of lists. First list are the headers.
        """
        tbl=[]
        data=""        
        delimiter = str(self.wnd.datadedit.text())
        qualifier = str(self.wnd.textqedit.text())        
        try:
            fname = str(self.wnd.pathedit.text())
            file = open(fname,"r")
            if not lines:
                data = file.read()
            else:
                for i in range(11):
                    try:
                        data = data+file.readline()
                    except:
                        pass
            rdata=DSV.organizeIntoLines(data, textQualifier = qualifier)
            tbl= DSV.importDSV(rdata, delimiter = delimiter, textQualifier = qualifier)            
        except:
            traceback.print_exc()
            return None
        return tbl
