"""XML export module

    begin                : 2003-01-26 00:37:12 rnc
    copyright            : (C) 2002 by Ricardo Niederberger Cabral
    email                : nieder|at|mail.ru
    Time-stamp:            <03/03/08 22:41:16 rnc>
"""

## ***************************************************************************
## *                                                                         *
## *   This program is free software; you can redistribute it and/or modify  *
## *   it under the terms of the GNU General Public License as published by  *
## *   the Free Software Foundation; either version 2 of the License, or     *
## *   (at your option) any later version.                                   *
## *                                                                         *
## ***************************************************************************

from xml.dom.minidom import *
from string import *
import time

from  dbExport import *
from imgSeekLib import __version__    


class dbExportXML(dbExport):
    def __init__(self,db,opts,batch):
        dbExport.__init__(self,db,opts)
        self.batch=batch
    def putDir(self,doc,parent,id):
        nnode=doc.createElement("Dir")
        nnode.setAttribute("id",str(id))
        nnode.setAttribute("parent-dir-id",str(self.curdb.dirs[id][1]))
        nnode.setAttribute("description",self.curdb.dirs[id][5])
        nnode.setAttribute("volume-id",str(self.curdb.dirs[id][6]))
        for dir in self.curdb.dirs[id][2]:
            self.putDir(doc,nnode,dir)
        for img in self.curdb.dirs[id][3]:            
            nnode2=doc.createElement("Image")
            nnode2.setAttribute("id",str(img))
            nnode.appendChild(nnode2)
        parent.appendChild(nnode)                
    def putGroup(self,doc,parent,id):
        nnode=doc.createElement("Group")
        nnode.setAttribute("id",str(id))
        nnode.setAttribute("parent-group-id",str(self.curdb.groups[id][2]))
        nnode.setAttribute("description",self.curdb.groups[id][1])
        nnode.setAttribute("name",self.curdb.groups[id][0])        
        for dir in self.curdb.groups[id][4]:
            self.putGroup(doc,nnode,dir)
        for img in self.curdb.groups[id][3]:            
            nnode2=doc.createElement("Image")
            nnode2.setAttribute("id",str(img))
            nnode.appendChild(nnode2)
        parent.appendChild(nnode)
    def do(self):
        """# export only metadata """
        try:
            outbatch=open(self.opts["outdir"]+"batch.xml","w")
            outimgs=open(self.opts["outdir"]+"imgs.xml","w")            
        except:
            traceback.print_exc()
            return
            print "Error opening output file for writing"        
        batchdoc = Document()
        nbatch = batchdoc.createElement("Batch")
        nbatch.setAttribute("creation-time",time.asctime(time.localtime()))        
        nbatch.setAttribute("imgSeek-version",__version__)
        nbatch.setAttribute("db-version",str(self.curdb.dbversion))
        batchdoc.appendChild(nbatch)
        
        #newel = newdoc.createElement("image")

        #newel.appendChild(newdoc.createTextNode("asdasd"))
        #newdoc.appendChild(newel)
        for it in self.batch:
            if it[0] == "SysDir":
                nnode=batchdoc.createElement("SysDir")
                nnode.setAttribute("path",it[1])
                nbatch.appendChild(nnode)
            if it[0] == "Dir":
                self.putDir(batchdoc,nbatch,it[1])
            if it[0] == "Group":
                self.putGroup(batchdoc,nbatch,it[1])
            if it[0] == "SimGroup":
                nnode=batchdoc.createElement("SimGroup")
                id=it[1]
                nnode.setAttribute("id",str(id))
                nnode.setAttribute("main-image-id",str(self.curdb.simgroups[id][1]))
                for img in self.curdb.simgroups[id][2]:
                    nnode2=batchdoc.createElement("Image")
                    nnode2.setAttribute("id",str(img))
                    nnode.appendChild(nnode2)
                nbatch.appendChild(nnode)
            if it[0] == "Img":
                nnode2=batchdoc.createElement("Image")
                nnode2.setAttribute("id",str(it[1]))
                nbatch.appendChild(nnode2)
            if it[0] == "Volume":
                id=it[1]
                nnode=batchdoc.createElement("Volume")
                nnode.setAttribute("id",str(id))
                nnode.setAttribute("base-path",self.curdb.volumes[id][1])
                nnode.setAttribute("description",self.curdb.volumes[id][2])
                nnode.setAttribute("name",self.curdb.volumes[id][3])
                for img in self.curdb.volumes[id][0]:
                    self.putDir(batchdoc,nnode,img)
                nbatch.appendChild(nnode)                
            if it[0] == "File":
                nnode=batchdoc.createElement("SysFile")
                nnode.setAttribute("path",it[1])
                nbatch.appendChild(nnode)
        outbatch.write(batchdoc.toxml())
        del batchdoc
        batchdoc = Document()
        nbatch = batchdoc.createElement("ImageDatabase")
        nbatch.setAttribute("creation-time",time.asctime(time.localtime()))
        nbatch.setAttribute("imgSeek-version",__version__)
        nbatch.setAttribute("db-version",str(self.curdb.dbversion))
        batchdoc.appendChild(nbatch)
        lst=[]
        self.curdb.crawlBatchContentsForImg(self.batch,lst)
        for id in lst:
            try:
                nnode=batchdoc.createElement("Image")
                nnode.setAttribute("id",str(id))
                nnode.setAttribute("parent-dir-id",str(self.curdb.img[id][1]))
                nnode.setAttribute("path",self.curdb.img[id][0])
                nbatch.appendChild(nnode)
                try:
                    for gid in self.curdb.img[id][2]:
                        nnode2=batchdoc.createElement("Group")
                        nnode2.setAttribute("id",str(gid))
                        nnode.appendChild(nnode2)
                except:
                    pass
                try:
                    for fld in self.curdb.meta[id].keys():
                        newel = batchdoc.createElement("meta")
                        newel.setAttribute("field",str(fld))
                        newel.appendChild(batchdoc.createTextNode(str(self.curdb.meta[id][fld])))
                        nnode.appendChild(newel)
                except:
                    pass
            except:
                pass                
        outimgs.write(batchdoc.toxml())
        outbatch.close()
        outimgs.close()
        self.done()
        xmlfiles=[self.opts["outdir"]+"batch.xml",self.opts["outdir"]+"imgs.xml"]
        outmsg="Data succesfully exported:\n"
        for xmf in xmlfiles:
            outmsg=outmsg+xmf+"\n"
        return outmsg

